(define-module lmn.util (export *debug* dump delete1!))
(select-module lmn.util)

(define *debug* #f)
(define *debug-level* 1)

(define (dump dlevel :rest args)
  (when *debug*
    (apply print (append (make-list (max *debug-level* 0) " |  ")
                         (map x->string args)))
    (inc! *debug-level* dlevel)
    (flush)))

(define (delete1! x lst :optional [elt=? equal?])
  ;; Like delete! but deletes at most one element.
  (cond [(null? lst) lst]
        [(elt=? x (car lst)) (cdr lst)]
        [else (cons (car lst) (delete1! x (cdr lst) elt=?))]))
